//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www.kamami.com
// PROJECT  : KAmodTEM Example
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple example of KAmodTEM using with ZL15AVR board
//
//    Settings and connections on ZL15AVR:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - PD4 (con18)
//        D5 (LCD_CHAR/con13) - PD5 (con18)
//        D6 (LCD_CHAR/con13) - PD6 (con18)
//        D7 (LCD_CHAR/con13) - PD7 (con18)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con15)
//
//   Connections between ZL15AVR and KAmodTEM :
//		  JP1 (ZL15AVR) - JP1 or JP2 (KAmodTEM)	
//
//******************************************************************************
#define F_CPU 2000000

#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>

#include "KAmodTEM.h"
#include "HD44780.h"
//******************************************************************************
//
//******************************************************************************
char fract[] = {'0','1','1','2','3','3','4','4','5','6','6','7','8','8','9','9'};
char degPattern[] = {6, 9, 9, 6, 32, 32, 32, 32, 0};
//******************************************************************************
// Main program
//******************************************************************************
int main(void)
{
char i;
unsigned int temp = 0;
char str[8];

LCD_Initialize();	// Initialization
KAmodTEM_Init();	// 

KAmodTEM_WriteReg(0, CONFIGURATION, 0b01100000); // 12-bit resolution


LCD_WriteCommand(64);		//
LCD_WriteText(degPattern);	// write custom font to CGRAM

LCD_GoTo(0,0);						// Welcome screen
LCD_WriteText("*** KAmodTEM ***");	//
LCD_GoTo(0,1);						//
LCD_WriteText("    Example");		//

for(i = 0; i < 40; i++)				// Some delay
  _delay_ms(50);					// 

LCD_GoTo(0,1);						// Clear second line
LCD_WriteText("                ");	// 
// Loop
do{
	temp = KAmodTEM_ReadReg(0, TEMPERATURE);	// Read tempereture register
	LCD_GoTo(4,1);
	LCD_WriteText("T:");
	LCD_WriteText(itoa(temp >> 8, str, 10));	// Conversion to integer
	LCD_WriteData('.');
	temp >>= 4 ;
	temp &= 0x0F;
	LCD_WriteData(fract[temp]);					// Display fraction
	LCD_WriteData(8);							// and degree symbol
	LCD_WriteData('C');							//
	_delay_ms(100);
}while(1);
return 0;
}
//******************************************************************************
// End of file
//******************************************************************************
